/*
* ============================================================================
*  Name     : CStack from Stack.h
*  Part of  : Stack
*  Created  : 23.05.2005 by 
*  Description:
*     CStack DLL source
*  Version  :
*  Copyright: 
* ============================================================================
*/

//  Include Files  

#include "Stack.h"	// CStack
#include "Stack.pan"      	// panic codes


//  Member Functions

EXPORT_C CStack* CStack::NewLC()
    {
    CStack* self = new (ELeave) CStack;
    CleanupStack::PushL(self);
    self->ConstructL();
    return self;
    }


EXPORT_C CStack* CStack::NewL()
    {
    CStack* self = CStack::NewLC();
    CleanupStack::Pop(self);
    return self;
    }


CStack::CStack()
// note, CBase initialises all member variables to zero
    {
    }


void CStack::ConstructL()
    {
		iElements = new (ELeave) CArrayFixFlat<TInt>(10);
    }


EXPORT_C CStack::~CStack()
    {
		delete iElements;
    }

EXPORT_C TBool CStack::IsEmpty()
{
	return iElements->Count() == 0;
}

EXPORT_C void CStack::PushL(TInt aElement)
{
	iElements->AppendL(aElement);
}

EXPORT_C TInt CStack::Pop()
{
	TInt element = iElements->At(iElements->Count() - 1);
	iElements->Delete(iElements->Count() - 1);
	return element;
}

// End of file
