/*
-----------------------------------------------------------------------------

    StackTest.cpp - test application source

-----------------------------------------------------------------------------
*/

//  Include Files

#include "StackTest.h"

SUNIT_TESTCASE_TABLE_BEGIN(CStackTest)
	SUNIT_TESTCASE(TestEmpty);
	SUNIT_TESTCASE(TestPushAndPop);
SUNIT_TESTCASE_TABLE_END

void CStackTest::SetUpL()
{
	iStack = CStack::NewL();
}

void CStackTest::TearDown()
{
	delete iStack;
}

void CStackTest::TestEmpty()
{
	SUNIT_ASSERT(iStack->IsEmpty());
}

void CStackTest::TestPushAndPop()
{
	iStack->PushL(1);
	iStack->PushL(2);
	SUNIT_ASSERT(!iStack->IsEmpty());
	SUNIT_ASSERT(2 == iStack->Pop());
	SUNIT_ASSERT(!iStack->IsEmpty());
	SUNIT_ASSERT(1 == iStack->Pop());
	SUNIT_ASSERT(iStack->IsEmpty());
}


//  Exported Functions

EXPORT_C CTest* NewTest()
{
return new (ELeave) CStackTest();
}

#ifndef EKA2
GLDEF_C TInt E32Dll(TDllReason /*aReason*/)
{
return KErrNone;
}
#endif //EKA2

// End of file
